Index: cpp/frams/genetics/f4/f4_general.cpp
===================================================================
--- cpp/frams/genetics/f4/f4_general.cpp	(revision 1226)
+++ cpp/frams/genetics/f4/f4_general.cpp	(revision 1227)
@@ -17,4 +17,10 @@
 #endif
 
+
+#define BREAK_WHEN_REP_COUNTER_NULL //see comments where it is used
+#define EXTRA_STEP_CELL_DEVELOPMENT //see comments where it is used
+#define TREAT_BAD_CONNECTIONS_AS_INVALID_GENO //see comments where it is used
+
+
 void rolling_dec(double *v)
 {
@@ -27,7 +33,7 @@
 }
 
-int scanrec(const char* s, unsigned int slen, char stopchar)
-{
-	unsigned int i = 0;
+int scanrec(const char* s, size_t slen, char stopchar)
+{
+	size_t i = 0;
 	//DB( printf("    scan('%s', '%c')\n", s, stopchar); )
 	while (1)
@@ -36,5 +42,5 @@
 			return 1;
 		if (stopchar == s[i])  // bumped into stopchar
-			return i;
+			return int(i);
 		if (i < slen - 1) // s[i] is not the last char
 		{
@@ -58,18 +64,17 @@
 		i++;
 	}
-	return i;
-}
-
-
-f4_Cell::f4_Cell(int nname,
-	f4_Cell *ndad, int nangle, GeneProps newP)
-{
-	name = nname;
-	type = T_UNDIFF4;
+	return int(i);
+}
+
+
+f4_Cell::f4_Cell(int nnr, f4_Cell *ndad, int nangle, GeneProps newP)
+{
+	nr = nnr;
+	type = CELL_UNDIFF;
 	dadlink = ndad;
 	org = NULL;
 	genot = NULL;
 	gcur = NULL;
-	active = 1;
+	active = true;
 	repeat.clear();
 	//genoRange.clear(); -- implicit
@@ -83,9 +88,8 @@
 	zrot = 0;
 	//OM = Orient_1;
-	ctrl = 0;
 	inertia = 0.8;
 	force = 0.04;
 	sigmo = 2;
-	nolink = 0;
+	conns_count = 0;
 
 	// adjust firstend and OM if there is a stick dad
@@ -93,5 +97,5 @@
 	{
 		// make sure it is a stick (and not a stick f4_Cell!)
-		if (T_STICK4 == ndad->type)
+		if (ndad->type == CELL_STICK)
 		{
 			//firstend = ndad->lastend;
@@ -99,5 +103,5 @@
 			ndad->childcount++;
 		}
-		if (T_NEURON4 == ndad->type)
+		if (ndad->type == CELL_NEURON)
 		{
 			inertia = ndad->inertia;
@@ -112,13 +116,13 @@
 
 
-f4_Cell::f4_Cell(f4_Cells *nO, int nname, f4_node *ngeno, f4_node *ngcur, f4_Cell *ndad, int nangle, GeneProps newP)
-{
-	name = nname;
-	type = T_UNDIFF4;
+f4_Cell::f4_Cell(f4_Cells *nO, int nnr, f4_Node *ngeno, f4_Node *ngcur, f4_Cell *ndad, int nangle, GeneProps newP)
+{
+	nr = nnr;
+	type = CELL_UNDIFF;
 	dadlink = ndad;
 	org = nO;
 	genot = ngeno;
 	gcur = ngcur;
-	active = 1;
+	active = true;
 	repeat.clear();
 	//genoRange.clear(); -- implicit
@@ -135,9 +139,8 @@
 	zrot = 0;
 	//OM = Orient_1;
-	ctrl = 0;
 	inertia = 0.8;
 	force = 0.04;
 	sigmo = 2;
-	nolink = 0;
+	conns_count = 0;
 
 	// adjust firstend and OM if there is a stick dad
@@ -145,5 +148,5 @@
 	{
 		// make sure it is a stick (and not a stick f4_Cell!)
-		if (T_STICK4 == ndad->type)
+		if (ndad->type == CELL_STICK)
 		{
 			//firstend = ndad->lastend;
@@ -151,5 +154,5 @@
 			ndad->childcount++;
 		}
-		if (T_NEURON4 == ndad->type)
+		if (ndad->type == CELL_NEURON)
 		{
 			inertia = ndad->inertia;
@@ -166,11 +169,11 @@
 f4_Cell::~f4_Cell()
 {
-	// remove links
-	if (nolink)
+	// remove connections
+	if (conns_count)
 	{
 		int i;
-		for (i = nolink - 1; i >= 0; i--)
-			delete links[i];
-		nolink = 0;
+		for (i = conns_count - 1; i >= 0; i--)
+			delete conns[i];
+		conns_count = 0;
 	}
 }
@@ -178,16 +181,10 @@
 
 /* return codes:
-	>1 error at pos
-	0  halt development for a cycle
-	-1  development finished OK
+	1 error at pos
+	0  halt development (yield) for a cycle
 	*/
-int f4_Cell::onestep()
-{
-	if (gcur == NULL)
-	{
-		active = 0;
-		return 0;  // stop
-	}
-	while (NULL != gcur)
+int f4_Cell::oneStep()
+{
+	while (gcur != NULL)
 	{
 		//DB( printf("  %d (%d) executing '%c' %d\n", name, type, gcur->name, gcur->pos); )
@@ -195,7 +192,13 @@
 		// the current genotype code is processed
 		//genoRange.add(gcur->pos,gcur->pos+gcur->name.length()-1);
-		bool neuclasshandler = false; // if set to true, then there is a set of characters that can be assigned to a neuron class type
-		// old semantics, one-character
-		if (gcur->name.length() == 1)
+		bool neuclasshandler = false; // if set to true, then a separate neuron handler below will identify the neuroclass and assign the cell to the neuron type
+
+		// To detect what genes are valid neuroclass names, but do NOT have is_neuroclass==true
+		// (just as a curiosity to ensure we properly distinguish between, for example, the "G" neuron and "G" modifier):
+		//char *TMP = (char*)gcur->name.c_str();
+		//if (gcur->is_neuroclass==false && GenoOperators::parseNeuroClass(TMP,ModelEnum::SHAPETYPE_BALL_AND_STICK))
+		//	printf("Could be a valid neuroclass, but is_neuroclass==false: %s\n", gcur->name.c_str());
+
+		if (gcur->name.length() == 1 && gcur->neuclass == NULL) //one-character genes and not neuroclass names
 		{
 			genoRange.add(gcur->pos, gcur->pos);
@@ -209,5 +212,5 @@
 
 				// error: sticks cannot divide
-				if (T_STICK4 == type)
+				if (type == CELL_STICK)
 				{
 					// cannot fix
@@ -217,5 +220,5 @@
 
 				// undiff divides
-				if (T_UNDIFF4 == type)
+				if (type == CELL_UNDIFF)
 				{
 					// commacount is set only when daughter turns into X
@@ -224,13 +227,14 @@
 					GeneProps newP = P;
 					newP.propagateAlong(false);
-					f4_Cell *tmp = new f4_Cell(org, org->nc, genot, gcur->child2, this, commacount, newP);
+					f4_Cell *tmp = new f4_Cell(org, org->cell_count, genot, gcur->child2, this, commacount, newP);
 					tmp->repeat = repeat;
 					repeat.clear();
 					org->addCell(tmp);
 				}
-				// a neuron divides: create a new, duplicate links
-				if (T_NEURON4 == type) {
+				// a neuron divides: create a new, duplicate connections
+				if (type == CELL_NEURON)
+				{
 					// daughter cell
-					f4_Cell *tmp = new f4_Cell(org, org->nc, genot, gcur->child2,
+					f4_Cell *tmp = new f4_Cell(org, org->cell_count, genot, gcur->child2,
 						// has the same dadlink
 						this->dadlink, commacount, P);
@@ -238,13 +242,13 @@
 					repeat.clear();
 					// it is a neuron from start
-					tmp->type = T_NEURON4;
+					tmp->type = CELL_NEURON;
 					// it has the same type as the parent neuron
 					tmp->neuclass = neuclass;
-					// duplicate links
-					f4_CellLink *ll;
-					for (int i = 0; i < nolink; i++)
+					// duplicate connections
+					f4_CellConn *conn;
+					for (int i = 0; i < conns_count; i++)
 					{
-						ll = links[i];
-						tmp->addlink(ll->from, ll->w, ll->t);
+						conn = conns[i];
+						tmp->addConnection(conn->from, conn->weight);
 					}
 					org->addCell(tmp);
@@ -258,5 +262,5 @@
 			{
 				// finish
-				// see if there is a repet count
+				// see if there is a repeat count
 				if (repeat.top > 0)
 				{ // there is a repeat counter
@@ -280,4 +284,12 @@
 					{
 						repeat.pop();
+						// MacKo 2023-04: originally, there was no "break" nor "return" here (hence [[fallthrough]]; needed below for modern compilers) - not sure if this was intentional or overlooking.
+						// This case can be tested with "#0" in the genotype. Anyway, there seems to be no difference in outcomes with and without "break".
+						// However, falling through [[fallthrough]] below for count==0 causes performing repeat.push(repeat_ptr(gcur, 0)) while the very reason
+						// we are here is that repeat count==0 (one of the conditions for isNull()), so I opted to add "break", but marked this tentative decision using #define.
+						// The ultimate informed decision would require understanding all the logic and testing all the edge cases.
+#ifdef BREAK_WHEN_REP_COUNTER_NULL
+						break;
+#endif
 					}
 				}
@@ -285,8 +297,8 @@
 				{
 					// error: still undiff
-					if (T_UNDIFF4 == type)
+					if (type == CELL_UNDIFF)
 					{
 						// fix it: insert an 'X'
-						f4_node *insertnode = new f4_node("X", NULL, gcur->pos);
+						f4_Node *insertnode = new f4_Node("X", NULL, gcur->pos);
 						if (org->setRepairInsert(gcur->pos, gcur, insertnode)) // not in repair mode, release
 							delete insertnode;
@@ -294,11 +306,16 @@
 					}
 					repeat.clear();
-					active = 0;  // stop
+					active = false;  // stop
 					// eat up rest
+					int remaining_nodes = gcur->count() - 1;
+					if (remaining_nodes > 0)
+						logPrintf("f4_Cell", "oneStep", LOG_WARN, "Ignoring junk genetic code: %d node(s) at position %d", remaining_nodes, gcur->child->pos); //let's see an example of such a genotype...
 					gcur = NULL;
 					return 0;
 				}
 			}
+#ifndef BREAK_WHEN_REP_COUNTER_NULL
 			[[fallthrough]];
+#endif
 			case '#':
 			{
@@ -311,5 +328,5 @@
 					return 1;  // stop
 				}
-				repeat.push(repeat_ptr(gcur, gcur->i1));
+				repeat.push(repeat_ptr(gcur, gcur->reps));
 				gcur = gcur->child;
 				break;
@@ -324,5 +341,5 @@
 			{
 				// error: if neuron
-				if (T_NEURON4 == type)
+				if (type == CELL_NEURON)
 				{
 					// fix: delete it
@@ -354,6 +371,7 @@
 			{
 				// error: if neuron
-				if (T_NEURON4 == type)
-				{
+				if (type == CELL_NEURON) //some neurons have the same single-letter names as modifiers (for example G,S,D), but they are supposed to have is_neuroclass==true so they should indeed not be handled here
+				{//however, what we see here is actually modifiers such as IdqEbWL (so not valid neuroclasses) that occurred within an already differentiated cell type==CELL_NEURON.
+					//printf("Handled as a modifier, but type==CELL_NEURON: '%c'\n", name);
 					// fix: delete it
 					org->setRepairRemove(gcur->pos, gcur);
@@ -368,5 +386,5 @@
 				// turn undiff. cell into a stick
 				// error: already differentiated
-				if (T_UNDIFF4 != type)
+				if (type != CELL_UNDIFF)
 				{
 					// fix: delete this node
@@ -374,5 +392,5 @@
 					return 1;  // stop
 				}
-				type = T_STICK4;
+				type = CELL_STICK;
 				// fix dad commacount and own anglepos
 				if (NULL != dadlink)
@@ -381,20 +399,13 @@
 					anglepos = dadlink->commacount;
 				}
-				// change of type halts developments, see comment at 'N'
+				// change of type halts developments, see comment at 'neuclasshandler' below
 				gcur = gcur->child;
 				return 0;
 			}
-			case 'N':
-			{
-				// turn undiff. cell into a neuron
-				// error: already differentiated
-				if (T_UNDIFF4 != type)
-				{
-					// fix: delete this node
-					org->setRepairRemove(gcur->pos, gcur);
-					return 1;  // stop
-				}
-				// error: if no previous
-				if (NULL == dadlink)
+			case '[':
+			{
+				// connection to neuron
+				// error: not a neuron
+				if (type != CELL_NEURON)
 				{
 					// fix: delete it
@@ -402,32 +413,91 @@
 					return 1;  // stop
 				}
-				string temp1 = "N";
-				char *temp = (char*)temp1.c_str();
-				neuclass = GenoOperators::parseNeuroClass(temp);
-				type = T_NEURON4;
-				// change of type also halts development, to give other
-				// cells a chance for adjustment.  Namely, it is important
-				// to wait for other cells to turn N before adding links
+				// input [%d:%g]
+				int relfrom = gcur->conn_from;
+				double weight = gcur->conn_weight;
+				f4_Cell *neu_from = NULL;
+
+				// input from other neuron
+				// find neuron at relative i
+				// find own index
+				int this_index = 0, neu_counter = 0;
+				for (int i = 0; i < org->cell_count; i++)
+				{
+					if (org->C[i]->type == CELL_NEURON) neu_counter++;
+					if (org->C[i] == this) { this_index = neu_counter - 1; break; }
+				}
+				// find index of incoming
+				int from_index = this_index + relfrom;
+
+				if (from_index < 0) goto wait_conn;
+				if (from_index >= org->cell_count) goto wait_conn;
+
+				// find that neuron
+				neu_counter = 0;
+				int from;
+				for (from = 0; from < org->cell_count; from++)
+				{
+					if (org->C[from]->type == CELL_NEURON) neu_counter++;
+					if (from_index == (neu_counter - 1)) break;
+				}
+				if (from >= org->cell_count) goto wait_conn;
+				neu_from = org->C[from];
+
+				// add connection
+				// error: could not add connection (too many?)
+				if (addConnection(neu_from, weight))
+				{
+					// cannot fix
+					org->setError(gcur->pos);
+					return 1;  // stop
+				}
 				gcur = gcur->child;
-				return 0;
-			}
-			case '@':
-			case '|':
-			{
-				// neuron rotating / bending
-				int j = 1;
-				if ('@' == name) j = 1; // rot
+				break;
+			}
+		wait_conn:
+			{
+				// wait for other neurons to develop
+				// if there are others still active
+
+				int active_count = 0;
+				for (int i = 0; i < org->cell_count; i++)
+					if (org->C[i]->active) active_count++;
+				active = false; // next time when we reach wait_conn, we will not count ourselves as active (if we were the last active cell, we got a chance to continue development for one development step only)
+				if (active_count > 0)
+					return 0;  // there is at least one active (including ourselves), halt, try again
+
+#ifdef TREAT_BAD_CONNECTIONS_AS_INVALID_GENO // MacKo 2023-04: there were so many invalid connections accumulating in the genotype (and stopping processing of the chain of gcur->child) that it looks like treating them as errors is better... in 2000's, Framsticks neurons were flexible when it comes to inputs and outputs (for example, when asked, muscles would provide an output too, and neurons that ignored inputs would still accept them when connected) so f4 could create connections pretty randomly, but after 2000's we attempt to respect neurons' getPreferredInputs() and getPreferredOutput() so the network of connections has more constraints.
+				if (gcur->parent->name == "#")
+				{
+					// MacKo 2023-04: Unfortunately the logic of multiplicating connections is not ideal...
+					//TREAT_BAD_CONNECTIONS_AS_INVALID_GENO without this "#" exception would break /*4*/<X>N:N#5<[1:1]>
+					// because every neuron wants to get an input from the neuron that will be created next
+					// and all is fine until the last created neuron, which wants to get an input from another one which will not be created
+					// (3 gets from 4, 4 gets from 5, 5 wants to get from 6 (relative connection offset for each of them is 1),
+					// but 6 will not get created and if we want to TREAT_BAD_CONNECTIONS_AS_INVALID_GENO, we produce an error...
+					// We would like to have this multiplication working, but OTAH we don't want to accept bad connections because then they tend to multiply as junk genes and bloat the genotype also causing more and more neutral mutations...
+					//so this condition and checking for "#" is a simple way to be kind to some, but not all, bad connections, and not raise errors. Perhaps too kind and we open the door for too many cases with invalid connections.
+					//Maybe it would be better to perform this check before addConnection(), seeing that for example we process the last iteration of the repetition counter? But how would we know that the (needed here) input neuron will not be developed later by other dividing cells...
+					active = true; //not sure if needed, but let this cell have the chance to continue for as long as many children in the tree are left
+					gcur = gcur->child;
+					return 0;
+				}
 				else
-					if ('|' == name) j = 2; // bend
-
-				// if undiff, then this is a new muscle. Thanks to f4_processrec @ and | case we can skip repairing
-				if (T_UNDIFF4 == type)
-				{
-					neuclasshandler = true;
-					break;
-				}
-
-				// error: not a neuron (stick)
-				if (T_NEURON4 != type)
+				{
+					//org->setError(gcur->pos); //in case setRepairRemove() would not always produce reasonable results
+					org->setRepairRemove(gcur->pos, gcur); //produces unexpected results? or NOT? TODO verify, some genotypes earlier produced strange outcomes of this repair (produced a valid genotype, but some neurons were multiplied/copied after repair - maybe because when a branch of '<' (or something else) is missing, the other branch is copied?)
+					return 1;  // stop
+				}
+#else
+				// no more actives, cannot add connection, ignore, but treat not as an error - before 2023-04
+				gcur = gcur->child;
+#endif
+			}
+			break;
+			case ':':
+			{
+				// neuron parameter
+				// error: not a neuron
+				if (type != CELL_NEURON)
 				{
 					// fix: delete it
@@ -435,122 +505,8 @@
 					return 1;  // stop
 				}
-				// error: already has control
-				if (ctrl != 0)
-				{
-					// fix: delete it
-					org->setRepairRemove(gcur->pos, gcur);
-					return 1;  // stop
-				}
-				// make neuron ctrl = 1 or 2
-				ctrl = j;
-				gcur = gcur->child;
-				break;
-			}
-			case '[':
-			{
-				// link to neuron
-				// error: not a neuron
-				if (T_NEURON4 != type)
-				{
-					// fix: delete it
-					org->setRepairRemove(gcur->pos, gcur);
-					return 1;  // stop
-				}
-				// input (sensor or %d)
-				int t = gcur->i1;
-				int relfrom = gcur->l1;
-				float w = gcur->f1;
-				f4_Cell *tneu = NULL;
-				if (t < 0) // wrong sensor
-				{
-					string buf = "wrong sensor in link '";
-					buf.append(gcur->s1);
-					buf.append("'");
-					logMessage("f4_Cell", "onestep", LOG_ERROR, buf.c_str());
-					org->setRepairRemove(gcur->pos, gcur);
-					return 1;
-				}
-				else if (t > 0) // sensors
-				{
-					char *temp = (char*)gcur->s1.c_str();
-					NeuroClass *sensortest = GenoOperators::parseNeuroClass(temp);
-					if (sensortest == NULL || sensortest->getPreferredInputs() != 0)
-					{
-						// error: unknown code
-						string buf = "wrong sensor in link '";
-						buf.append(gcur->s1);
-						buf.append("'");
-						logMessage("f4_Cell", "onestep", LOG_ERROR, buf.c_str());
-						org->setRepairRemove(gcur->pos, gcur);
-						return 1;
-					}
-				}
-				else {
-					// input from other neuron
-					// find neuron at relative i
-					// find own index
-					int j = 0, k = 0;
-					for (int i = 0; i < org->nc; i++)
-					{
-						if (org->C[i]->type == T_NEURON4) k++;
-						if (org->C[i] == this) { j = k - 1; break; }
-					}
-					// find index of incoming
-					j = j + relfrom;
-					if (j < 0) goto wait_link;
-					if (j >= org->nc) goto wait_link;
-					// find that neuron
-					k = 0;
-					int i;
-					for (i = 0; i < org->nc; i++)
-					{
-						if (org->C[i]->type == T_NEURON4) k++;
-						if (j == (k - 1)) break;
-					}
-					if (i >= org->nc) goto wait_link;
-					tneu = org->C[i];
-				}
-				// add link
-				// error: could not add link (too many?)
-				if (addlink(tneu, w, gcur->s1))
-				{
-					// cannot fix
-					org->setError(gcur->pos);
-					return 1;  // stop
-				}
-				gcur = gcur->child;
-				break;
-			}
-		wait_link:
-			{
-				// wait for other neurons to develop
-				// if there are others still active
-				active = 0;
-				int j = 0;
-				for (int i = 0; i < org->nc; i++)
-				{
-					if (org->C[i]->active) j++;
-				}
-				if (j > 0)
-					return 0;  // there is other active, halt, try again
-				// no more actives, cannot add link, ignore, but treat not as an error
-				gcur = gcur->child;
-			}
-			break;
-			case ':':
-			{
-				// neuron parameter
-				// error: not a neuron
-				if (T_NEURON4 != type)
-				{
-					// fix: delete it
-					org->setRepairRemove(gcur->pos, gcur);
-					return 1;  // stop
-				}
-				int j = gcur->l1;
-				switch ((char)gcur->i1)
+				switch (gcur->prop_symbol)
 				{
 				case '!':
-					if (j)
+					if (gcur->prop_increase)
 						force += (1.0 - force) * 0.2;
 					else
@@ -558,5 +514,5 @@
 					break;
 				case '=':
-					if (j)
+					if (gcur->prop_increase)
 						inertia += (1.0 - inertia) * 0.2;
 					else
@@ -564,5 +520,5 @@
 					break;
 				case '/':
-					if (j)
+					if (gcur->prop_increase)
 						sigmo *= 1.4;
 					else
@@ -586,5 +542,5 @@
 			default:
 			{
-				// because there are one-character neuron classes, default move control to neuclasshandler
+				// because there are one-character neuron classes, default is move control to neuclasshandler
 				neuclasshandler = true;
 			}
@@ -593,5 +549,5 @@
 		else
 		{
-			// if many characters, then it needs to be parsed below
+			// if many characters or single character but is_neuroclass, then it will be handled below
 			neuclasshandler = true;
 		}
@@ -599,6 +555,6 @@
 		if (neuclasshandler)
 		{
-			genoRange.add(gcur->pos, gcur->pos + gcur->name.length() + 2 - 1); // +2 for N:
-			if (T_UNDIFF4 != type)
+			genoRange.add(gcur->pos, gcur->pos + int(gcur->name.length()) + 2 - 1); // +2 for N:
+			if (type != CELL_UNDIFF)
 			{
 				// fix: delete this node
@@ -607,5 +563,5 @@
 			}
 			// error: if no previous
-			if (NULL == dadlink)
+			if (dadlink == NULL)
 			{
 				// fix: delete it
@@ -613,35 +569,35 @@
 				return 1;  // stop
 			}
-			// multiple characters are neuron types. Need to check if exists
+			// multiple characters are neuron types. Let's check if exists in the current configuration of Framsticks
 			char *temp = (char*)gcur->name.c_str();
-			neuclass = GenoOperators::parseNeuroClass(temp);
+			neuclass = GenoOperators::parseNeuroClass(temp, ModelEnum::SHAPETYPE_BALL_AND_STICK);
 			if (neuclass == NULL)
 			{
 				// error: unknown code
-				string buf = "unknown code '";
-				buf.append(gcur->name);
-				buf.append("'");
-				logMessage("f4_Cell", "onestep", 2, buf.c_str());
+				string buf = "Unknown code '" + gcur->name + "'";
+				logMessage("f4_Cell", "oneStep", LOG_ERROR, buf.c_str());
 				org->setRepairRemove(gcur->pos, gcur);
 				return 1;
 			}
-			type = T_NEURON4; //they belong to neurons
+			type = CELL_NEURON;
+			// change of type also halts development, to give other
+			// cells a chance for adjustment.  Namely, it is important
+			// to wait for other cells to turn to neurons before adding connections
 			gcur = gcur->child;
 			return 0; //stop
 		}
 	}
-	active = 0;  // done
+	active = false;  // done
 	return 0;
 }
 
 
-int f4_Cell::addlink(f4_Cell *nfrom, double nw, string nt)
-{
-	// if incoming neuron does not produce output, return error
-	if (nfrom != NULL && nfrom->neuclass->getPreferredOutput() == 0) return -1;
-	if (neuclass->getPreferredInputs() != -1 && nolink >= neuclass->getPreferredInputs()) return -1;
-	if (nolink >= MAXINPUTS - 1) return -1; // full!
-	links[nolink] = new f4_CellLink(nfrom, nw, nt);
-	nolink++;
+int f4_Cell::addConnection(f4_Cell *nfrom, double nweight)
+{
+	if (nfrom->neuclass->getPreferredOutput() == 0) return -1; // if incoming neuron does not produce output, return error
+	if (neuclass->getPreferredInputs() != -1 && conns_count >= neuclass->getPreferredInputs()) return -1; //cannot add more inputs to this neuron
+	if (conns_count >= F4_MAX_CELL_INPUTS - 1) return -1; // over hardcoded limit
+	conns[conns_count] = new f4_CellConn(nfrom, nweight);
+	conns_count++;
 	return 0;
 }
@@ -661,19 +617,19 @@
 
 	// make sure its parent is processed first
-	if (NULL != dadlink)
+	if (dadlink != NULL)
 		dadlink->adjustRec();
 
 	// count children
 	childcount = 0;
-	for (i = 0; i < org->nc; i++)
+	for (i = 0; i < org->cell_count; i++)
 	{
 		if (org->C[i]->dadlink == this)
-			if (org->C[i]->type == T_STICK4)
+			if (org->C[i]->type == CELL_STICK)
 				childcount++;
 	}
 
-	if (type == T_STICK4)
-	{
-		if (NULL == dadlink)
+	if (type == CELL_STICK)
+	{
+		if (dadlink == NULL)
 		{
 			//firstend = Pt3D_0;
@@ -721,18 +677,17 @@
 
 
-f4_CellLink::f4_CellLink(f4_Cell *nfrom, double nw, string nt)
+f4_CellConn::f4_CellConn(f4_Cell *nfrom, double nweight)
 {
 	from = nfrom;
-	w = nw;
-	t = nt;
-}
-
-
-
-f4_Cells::f4_Cells(f4_node *genome, int nrepair)
+	weight = nweight;
+}
+
+
+
+f4_Cells::f4_Cells(f4_Node *genome, int nrepair)
 {
 	// create ancestor cell
 	repair = nrepair;
-	error = 0;
+	errorcode = GENOPER_OK;
 	errorpos = -1;
 	repair_remove = NULL;
@@ -742,5 +697,5 @@
 	f4rootnode = NULL;
 	C[0] = new f4_Cell(this, 0, genome, genome, NULL, 0, GeneProps::standard_values);
-	nc = 1;
+	cell_count = 1;
 }
 
@@ -750,5 +705,5 @@
 	int res;
 	repair = nrepair;
-	error = 0;
+	errorcode = GENOPER_OK;
 	errorpos = -1;
 	repair_remove = NULL;
@@ -759,9 +714,9 @@
 
 	// transform geno from string to nodes
-	f4rootnode = new f4_node();
-	res = f4_processrec(genome.c_str(), (unsigned)0, f4rootnode);
+	f4rootnode = new f4_Node();
+	res = f4_processrec(genome.c_str(), 0, f4rootnode);
 	if ((res < 0) || (1 != f4rootnode->childCount()))
 	{
-		error = GENOPER_OPFAIL;
+		errorcode = GENOPER_OPFAIL;
 		errorpos = -1;
 	}
@@ -769,5 +724,5 @@
 	// create ancestor cell
 	C[0] = new f4_Cell(this, 0, f4rootnode->child, f4rootnode->child, NULL, 0, GeneProps::standard_values);
-	nc = 1;
+	cell_count = 1;
 }
 
@@ -776,9 +731,9 @@
 	// release cells
 	int i;
-	if (nc)
-	{
-		for (i = nc - 1; i >= 0; i--)
+	if (cell_count)
+	{
+		for (i = cell_count - 1; i >= 0; i--)
 			delete C[i];
-		nc = 0;
+		cell_count = 0;
 	}
 	if (f4rootnode)
@@ -787,23 +742,21 @@
 
 
-int f4_Cells::onestep()
-{
-	int i, ret, oldnc, ret2;
-	oldnc = nc;
-	ret = 0;
-	for (i = 0; i < oldnc; i++)
-	{
-		ret2 = C[i]->onestep();
-		if (ret2 > 0)
+bool f4_Cells::oneStep()
+{
+	int old_cell_count = cell_count; //cell_count may change in the loop as new cells may be appended because cells may be dividing
+	for (int i = 0; i < old_cell_count; i++)
+	{
+		int cellstep_ret = C[i]->oneStep(); //keeps calling independently of C[i]->active
+		if (cellstep_ret > 0)
 		{
 			// error
-			C[i]->active = 0;  // stop
-			return 0;
-		}
-		// if still active
+			C[i]->active = false;  // stop
+			return false;
+		}
+	}
+	for (int i = 0; i < cell_count; i++) //we check all cells, including newly created ones
 		if (C[i]->active)
-			ret = 1;
-	}
-	return ret;
+			return true; //at least one cell is still active. TODO maybe the development should stop NOT because of the "active" field (there is this strange "yielding" state too), but by observing the progress of all cells and continuing the development while (errorcode==0 AND (gcur of at least one cell changed OR cell_count changed)) ? Also get rid of return 1/return 0, just observe error.
+	return false;
 }
 
@@ -811,20 +764,31 @@
 int f4_Cells::simulate()
 {
-	int i;
-	error = GENOPER_OK;
-
-	for (i = 0; i < nc; i++)  C[i]->active = 1;
-
-	// execute onestep() in a cycle
-	while (onestep());
-
-	if (GENOPER_OK != error) return error;
+	constexpr bool print_debugging = false; //print the state of cells during development
+	errorcode = GENOPER_OK;
+
+	for (int i = 0; i < cell_count; i++)  C[i]->active = true;
+
+	if (print_debugging) f4_Node::print_tree(C[0]->genot, 0);
+	if (print_debugging) print_cells("Initialization");
+
+	// execute oneStep() in a cycle
+	while (oneStep()) if (print_debugging) print_cells("Development step");
+	if (print_debugging) print_cells("After last development step");
+
+#ifdef EXTRA_STEP_CELL_DEVELOPMENT
+	if (errorcode == GENOPER_OK)
+	{
+		oneStep(); if (print_debugging) print_cells("After extra step"); //for these "halted" (yielding) cells (they have active==false) that wait for other cells to develop. Without this step, the last, recently halted one(s) may miss the "retrying" step if all active==true cells became active==false in the last step.
+	}
+#endif
+
+	if (errorcode != GENOPER_OK) return errorcode;
 
 	// fix neuron attachements
-	for (i = 0; i < nc; i++)
-	{
-		if (C[i]->type == T_NEURON4)
-		{
-			while (T_NEURON4 == C[i]->dadlink->type)
+	for (int i = 0; i < cell_count; i++)
+	{
+		if (C[i]->type == CELL_NEURON)
+		{
+			while (C[i]->dadlink->type == CELL_NEURON)
 			{
 				C[i]->dadlink = C[i]->dadlink->dadlink;
@@ -835,10 +799,10 @@
 	// there should be no undiff. cells
 	// make undifferentiated cells sticks
-	for (i = 0; i < nc; i++)
-	{
-		if (C[i]->type == T_UNDIFF4)
-		{
-			C[i]->type = T_STICK4;
-			//seterror();
+	for (int i = 0; i < cell_count; i++)
+	{
+		if (C[i]->type == CELL_UNDIFF)
+		{
+			C[i]->type = CELL_STICK;
+			//setError();
 		}
 	}
@@ -846,13 +810,41 @@
 	// recursive adjust
 	// reset recursive traverse flags
-	for (i = 0; i < nc; i++)
+	for (int i = 0; i < cell_count; i++)
 		C[i]->recProcessedFlag = 0;
 	// process every cell
-	for (i = 0; i < nc; i++)
+	for (int i = 0; i < cell_count; i++)
 		C[i]->adjustRec();
 
 	//DB( printf("Cell simulation done, %d cells. \n", nc); )
 
-	return error;
+	if (print_debugging) print_cells("Final");
+
+	return errorcode;
+}
+
+
+void f4_Cells::print_cells(const char* description)
+{
+	printf("------ %-55s ------ errorcode=%d, errorpos=%d\n", description, getErrorCode(), getErrorPos());
+	for (int i = 0; i < cell_count; i++)
+	{
+		f4_Cell *c = C[i];
+		string type;
+		switch (c->type)
+		{
+		case CELL_UNDIFF: type = "UNDIFF"; break;
+		case CELL_STICK:  type = "STICK"; break;
+		case CELL_NEURON: type = string("NEURON:") + c->neuclass->name.c_str(); break;
+		default: type = std::to_string(c->type);
+		}
+		const char *status = c->active ? "active" : (c->gcur != NULL ? "yielding" : ""); //yielding = not active but waiting for other cells
+		printf("%2d(%-8s)  nr=%d \t type=%-15s \t genot=%s \t gcurrent=%s", i, status, c->nr, type.c_str(), c->genot->name.c_str(), c->gcur ? c->gcur->name.c_str() : "null");
+		if (c->gcur && c->gcur->name == "[")
+			printf("\tfrom=%d  weight=%g", c->gcur->conn_from, c->gcur->conn_weight);
+		printf("\n");
+		for (int l = 0; l < c->conns_count; l++)
+			printf("\tconn:%d from=%d weight=%g\n", l, c->conns[l]->from->nr, c->conns[l]->weight);
+	}
+	printf("\n");
 }
 
@@ -860,11 +852,11 @@
 void f4_Cells::addCell(f4_Cell *newcell)
 {
-	if (nc >= MAX4CELLS - 1)
+	if (cell_count >= F4_MAX_CELLS - 1)
 	{
 		delete newcell;
 		return;
 	}
-	C[nc] = newcell;
-	nc++;
+	C[cell_count] = newcell;
+	cell_count++;
 }
 
@@ -872,19 +864,19 @@
 void f4_Cells::setError(int nerrpos)
 {
-	error = GENOPER_OPFAIL;
+	errorcode = GENOPER_OPFAIL;
 	errorpos = nerrpos;
 }
 
-void f4_Cells::setRepairRemove(int nerrpos, f4_node *rem)
+void f4_Cells::setRepairRemove(int nerrpos, f4_Node *rem)
 {
 	if (!repair)
 	{
 		// not in repair mode, treat as repairable error
-		error = GENOPER_REPAIR;
+		errorcode = GENOPER_REPAIR;
 		errorpos = nerrpos;
 	}
 	else
 	{
-		error = GENOPER_REPAIR;
+		errorcode = GENOPER_REPAIR;
 		errorpos = nerrpos;
 		repair_remove = rem;
@@ -892,10 +884,10 @@
 }
 
-int f4_Cells::setRepairInsert(int nerrpos, f4_node *parent, f4_node *insert)
+int f4_Cells::setRepairInsert(int nerrpos, f4_Node *parent, f4_Node *insert)
 {
 	if (!repair)
 	{
 		// not in repair mode, treat as repairable error
-		error = GENOPER_REPAIR;
+		errorcode = GENOPER_REPAIR;
 		errorpos = nerrpos;
 		return -1;
@@ -903,5 +895,5 @@
 	else
 	{
-		error = GENOPER_REPAIR;
+		errorcode = GENOPER_REPAIR;
 		errorpos = nerrpos;
 		repair_parent = parent;
@@ -911,24 +903,28 @@
 }
 
-void f4_Cells::repairGeno(f4_node *geno, int whichchild)
+void f4_Cells::repairGeno(f4_Node *geno, int whichchild)
 {
 	// assemble repaired geno, if the case
 	if (!repair) return;
-	if ((NULL == repair_remove) && (NULL == repair_insert)) return;
+	if ((repair_remove == NULL) && (repair_insert == NULL)) return;
 	// traverse genotype tree, remove / insert node
-	f4_node *g2;
-	if (1 == whichchild) g2 = geno->child;
-	else             g2 = geno->child2;
-	if (NULL == g2)
+	f4_Node *g2;
+	if (whichchild == 1)
+		g2 = geno->child;
+	else
+		g2 = geno->child2;
+	if (g2 == NULL)
 		return;
 	if (g2 == repair_remove)
 	{
-		f4_node *oldgeno;
+		f4_Node *oldgeno;
 		geno->removeChild(g2);
 		if (g2->child)
 		{
 			// add g2->child as child to geno
-			if (1 == whichchild) geno->child = g2->child;
-			else             geno->child2 = g2->child;
+			if (whichchild == 1)
+				geno->child = g2->child;
+			else
+				geno->child2 = g2->child;
 			g2->child->parent = geno;
 		}
@@ -936,5 +932,5 @@
 		oldgeno->child = NULL;
 		delete oldgeno;
-		if (NULL == geno->child) return;
+		if (geno->child == NULL) return;
 		// check this new
 		repairGeno(geno, whichchild);
@@ -973,10 +969,10 @@
 	char buf[200];
 
-	if (curc >= nc) return;
-
-	if (T_STICK4 != C[curc]->type) return;
+	if (curc >= cell_count) return;
+
+	if (C[curc]->type != CELL_STICK) return;
 
 	thisti = C[curc];
-	if (NULL != thisti->dadlink)
+	if (thisti->dadlink != NULL)
 		*tmpcel = *(thisti->dadlink);
 
